@use './styles/navigation-vertical-menu.variables' as *;

:host {
  @include digi-navigation-vertical-menu--variables;

  .digi-navigation-vertical-menu {
    display: block;
    background: var(--digi--navigation-vertical-menu--background);
  }
}


::slotted(.digi-navigation-vertical-menu--indicator--secondary ul.digi-navigation-vertical-menu__list--root) {

  &.secondary {
    --subnav-indicator--width: var(--subnav-indicator--width--xl);

    .digi-navigation-vertical-menu-item {
      --digi--navigation-vertical-menu-item--active-indicator-width: var(--subnav-indicator--width--xl);
    }
  }
}


::slotted(* ul.digi-navigation-vertical-menu__list--root) {
  --subnav-indicator--left: var(--digi--padding--medium);
  --subnav-indicator--width: 1px;
  --subnav-indicator--width--l: 4px;
  --subnav-indicator--width--xl: 6px;
  --subnav-indicator--background-color: var(--digi--color--border--neutral-4);
  --subnav-indicator--background-color--default: var(--digi--color--border--neutral-4);
  --subnav-indicator--background-color--current: var(--digi--color--border--neutral-1);

  &,
  ul,
  li {
    list-style: none;
    padding: 0;
    margin: 0;
  }

  > li {

    &:not(:first-child) {
      border-top: var(--digi--navigation-vertical-menu--item--border-top);
    }

    ul digi-navigation-vertical-menu-item {
      --digi--navigation-vertical-menu-item--font-size: var(--digi--typography--tag--font-size--desktop);
    }
  }

  // ----- PRIMARY variation
  &.primary {

    // ACTIVE li on first level
    > .digi-navigation-vertical-menu__item--active {
      padding-bottom: var(--digi--padding--small);
    } 

    // CURRENT LEVEL
    .digi-navigation-vertical-menu__item--current-level {   
      --subnav-indicator--background-color: var(--subnav-indicator--background-color--current);

      ul {
        --subnav-indicator--background-color: var(--subnav-indicator--background-color--default);
      }

      digi-navigation-vertical-menu-item {
        --digi--navigation-vertical-menu-item--active-indicator-width: 4px;
      }
    }

    // ACTIVE
    .digi-navigation-vertical-menu__item--active {
      position: relative;
  
      > ul {
        position: relative;
    
        &::before {
          content: "";
          display: inline-block;
          position: absolute;
          top: 0;
          bottom: 0;
          z-index: 1;
          left: var(--subnav-indicator--left);
          width: var(--subnav-indicator--width);
          background-color: var(--subnav-indicator--background-color);
        }

        .digi-navigation-vertical-menu-item {
          --digi--navigation-vertical-menu-item--active-indicator-left: var(--digi--padding--medium);
        }
    
        ul {
          --subnav-indicator--left: var(--digi--padding--largest);

          .digi-navigation-vertical-menu-item {
            --digi--navigation-vertical-menu-item--active-indicator-left: var(--digi--padding--largest);
          }
    
          ul {
            --subnav-indicator--left: calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--smaller)});

            .digi-navigation-vertical-menu-item {
              --digi--navigation-vertical-menu-item--active-indicator-left: calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--smaller)});
            }
            ul {
              --subnav-indicator--left: calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--largest)});

              .digi-navigation-vertical-menu-item {
                --digi--navigation-vertical-menu-item--active-indicator-left: calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--largest)});
              }
    
              ul {
                --subnav-indicator--left: calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--largest-2)});

                .digi-navigation-vertical-menu-item {
                  --digi--navigation-vertical-menu-item--active-indicator-left: calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--largest-2)});
                }
              }
            }
          }
        }
      }
    }

    &.digi-navigation-vertical-menu__item--current-level,
    .digi-navigation-vertical-menu__item--current-level {

      &::before {
        --subnav-indicator--width: var(--subnav-indicator--width--l);
      }
    }

    ul {
      .digi-navigation-vertical-menu-item {
        --digi--navigation-vertical-menu-item--padding: var(--digi--padding--small) var(--digi--padding--largest);
      }
      ul {
        .digi-navigation-vertical-menu-item {
          --digi--navigation-vertical-menu-item--padding: var(--digi--padding--small) var(--digi--padding--medium) var(--digi--padding--small) calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--smaller)});
        }
        ul {
          .digi-navigation-vertical-menu-item {
            --digi--navigation-vertical-menu-item--padding: var(--digi--padding--small) var(--digi--padding--medium) var(--digi--padding--small) calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--largest)});
          }
          ul {
            .digi-navigation-vertical-menu-item {
              --digi--navigation-vertical-menu-item--padding: var(--digi--padding--small) var(--digi--padding--medium) var(--digi--padding--small) calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--largest-2)});
            }
          }
        }
      }
    }
  }

  // ----- SECONDARY variation
  &.secondary {
    --subnav-indicator--width: var(--subnav-indicator--width--l);

    > .digi-navigation-vertical-menu__item--active {
      position: relative;
      
      &::before {
        content: "";
        display: inline-block;
        position: absolute;
        top: 0;
        bottom: 0;
        width: var(--subnav-indicator--width);
        background-color: var(--digi--color--background--neutral-7);
        z-index: 1;
      }
    }

    .digi-navigation-vertical-menu__item--deep-active {
      background-color: var(--digi--color--background--neutral-5);

      // > digi-navigation-vertical-menu-item, // Expanded toggle row
      > ul > li > digi-navigation-vertical-menu-item {
        --digi--navigation-vertical-menu-item--toggle-icon--background: var(--digi--color--background--primary);
        --digi--navigation-vertical-menu-item--toggle-icon--background--active: var(--digi--color--background--primary);
      }
    }

    ul {
      .digi-navigation-vertical-menu-item {
        --digi--navigation-vertical-menu-item--padding: var(--digi--padding--small) var(--digi--padding--largest);
      }
      ul {
        .digi-navigation-vertical-menu-item {
          --digi--navigation-vertical-menu-item--padding: var(--digi--padding--small) var(--digi--padding--medium) var(--digi--padding--small) calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--smaller)});
        }
        ul {
          .digi-navigation-vertical-menu-item {
            --digi--navigation-vertical-menu-item--padding: var(--digi--padding--small) var(--digi--padding--medium) var(--digi--padding--small) calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--largest)});
          }
          ul {
            .digi-navigation-vertical-menu-item {
              --digi--navigation-vertical-menu-item--padding: var(--digi--padding--small) var(--digi--padding--medium) var(--digi--padding--small) calc(#{var(--digi--padding--largest-2)} + #{var(--digi--padding--largest-2)});
            }
          }
        }
      }
    } 
  }
}



// DEMO - highlight items in demo
::slotted(* li.digi-navigation-vertical-menu__item--highlight) {

  > digi-navigation-vertical-menu-item {

    .digi-navigation-vertical-menu-item__button:first-child,
    .digi-navigation-vertical-menu-item__link:first-child {

      .digi-navigation-vertical-menu-item__text::after {
        display: inline-flex;
        position: relative;
        align-items: center;
        justify-content: center;
        overflow: hidden;
        content: "";
        width: #{rem(10)};
        height: #{rem(10)};
        border-radius: #{rem(10)};
        line-height: 1;
        transform: translateY(-5px);
        margin-left: var(--digi--padding--smaller);
        background: var(--digi--color--background--neutral-5);
      }
    }
  }
}